

# Actions
<a name="API_Operations"></a>

The following actions are supported:
+  [AssociateApi](API_AssociateApi.md) 
+  [AssociateMergedGraphqlApi](API_AssociateMergedGraphqlApi.md) 
+  [AssociateSourceGraphqlApi](API_AssociateSourceGraphqlApi.md) 
+  [CreateApi](API_CreateApi.md) 
+  [CreateApiCache](API_CreateApiCache.md) 
+  [CreateApiKey](API_CreateApiKey.md) 
+  [CreateChannelNamespace](API_CreateChannelNamespace.md) 
+  [CreateDataSource](API_CreateDataSource.md) 
+  [CreateDomainName](API_CreateDomainName.md) 
+  [CreateFunction](API_CreateFunction.md) 
+  [CreateGraphqlApi](API_CreateGraphqlApi.md) 
+  [CreateResolver](API_CreateResolver.md) 
+  [CreateType](API_CreateType.md) 
+  [DeleteApi](API_DeleteApi.md) 
+  [DeleteApiCache](API_DeleteApiCache.md) 
+  [DeleteApiKey](API_DeleteApiKey.md) 
+  [DeleteChannelNamespace](API_DeleteChannelNamespace.md) 
+  [DeleteDataSource](API_DeleteDataSource.md) 
+  [DeleteDomainName](API_DeleteDomainName.md) 
+  [DeleteFunction](API_DeleteFunction.md) 
+  [DeleteGraphqlApi](API_DeleteGraphqlApi.md) 
+  [DeleteResolver](API_DeleteResolver.md) 
+  [DeleteType](API_DeleteType.md) 
+  [DisassociateApi](API_DisassociateApi.md) 
+  [DisassociateMergedGraphqlApi](API_DisassociateMergedGraphqlApi.md) 
+  [DisassociateSourceGraphqlApi](API_DisassociateSourceGraphqlApi.md) 
+  [EvaluateCode](API_EvaluateCode.md) 
+  [EvaluateMappingTemplate](API_EvaluateMappingTemplate.md) 
+  [FlushApiCache](API_FlushApiCache.md) 
+  [GetApi](API_GetApi.md) 
+  [GetApiAssociation](API_GetApiAssociation.md) 
+  [GetApiCache](API_GetApiCache.md) 
+  [GetChannelNamespace](API_GetChannelNamespace.md) 
+  [GetDataSource](API_GetDataSource.md) 
+  [GetDataSourceIntrospection](API_GetDataSourceIntrospection.md) 
+  [GetDomainName](API_GetDomainName.md) 
+  [GetFunction](API_GetFunction.md) 
+  [GetGraphqlApi](API_GetGraphqlApi.md) 
+  [GetGraphqlApiEnvironmentVariables](API_GetGraphqlApiEnvironmentVariables.md) 
+  [GetIntrospectionSchema](API_GetIntrospectionSchema.md) 
+  [GetResolver](API_GetResolver.md) 
+  [GetSchemaCreationStatus](API_GetSchemaCreationStatus.md) 
+  [GetSourceApiAssociation](API_GetSourceApiAssociation.md) 
+  [GetType](API_GetType.md) 
+  [ListApiKeys](API_ListApiKeys.md) 
+  [ListApis](API_ListApis.md) 
+  [ListChannelNamespaces](API_ListChannelNamespaces.md) 
+  [ListDataSources](API_ListDataSources.md) 
+  [ListDomainNames](API_ListDomainNames.md) 
+  [ListFunctions](API_ListFunctions.md) 
+  [ListGraphqlApis](API_ListGraphqlApis.md) 
+  [ListResolvers](API_ListResolvers.md) 
+  [ListResolversByFunction](API_ListResolversByFunction.md) 
+  [ListSourceApiAssociations](API_ListSourceApiAssociations.md) 
+  [ListTagsForResource](API_ListTagsForResource.md) 
+  [ListTypes](API_ListTypes.md) 
+  [ListTypesByAssociation](API_ListTypesByAssociation.md) 
+  [PutGraphqlApiEnvironmentVariables](API_PutGraphqlApiEnvironmentVariables.md) 
+  [StartDataSourceIntrospection](API_StartDataSourceIntrospection.md) 
+  [StartSchemaCreation](API_StartSchemaCreation.md) 
+  [StartSchemaMerge](API_StartSchemaMerge.md) 
+  [TagResource](API_TagResource.md) 
+  [UntagResource](API_UntagResource.md) 
+  [UpdateApi](API_UpdateApi.md) 
+  [UpdateApiCache](API_UpdateApiCache.md) 
+  [UpdateApiKey](API_UpdateApiKey.md) 
+  [UpdateChannelNamespace](API_UpdateChannelNamespace.md) 
+  [UpdateDataSource](API_UpdateDataSource.md) 
+  [UpdateDomainName](API_UpdateDomainName.md) 
+  [UpdateFunction](API_UpdateFunction.md) 
+  [UpdateGraphqlApi](API_UpdateGraphqlApi.md) 
+  [UpdateResolver](API_UpdateResolver.md) 
+  [UpdateSourceApiAssociation](API_UpdateSourceApiAssociation.md) 
+  [UpdateType](API_UpdateType.md) 

# AssociateApi
<a name="API_AssociateApi"></a>

Maps an endpoint to your custom domain.

## Request Syntax
<a name="API_AssociateApi_RequestSyntax"></a>

```
POST /v1/domainnames/domainName/apiassociation HTTP/1.1
Content-type: application/json

{
   "apiId": "string"
}
```

## URI Request Parameters
<a name="API_AssociateApi_RequestParameters"></a>

The request uses the following URI parameters.

 ** [domainName](#API_AssociateApi_RequestSyntax) **   <a name="appsync-AssociateApi-request-uri-domainName"></a>
The domain name.  
Length Constraints: Minimum length of 1. Maximum length of 253.  
Pattern: `^(\*[\w\d-]*\.)?([\w\d-]+\.)+[\w\d-]+$`   
Required: Yes

## Request Body
<a name="API_AssociateApi_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [apiId](#API_AssociateApi_RequestSyntax) **   <a name="appsync-AssociateApi-request-apiId"></a>
The API ID. Private APIs can not be associated with custom domains.  
Type: String  
Required: Yes

## Response Syntax
<a name="API_AssociateApi_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "apiAssociation": { 
      "apiId": "string",
      "associationStatus": "string",
      "deploymentDetail": "string",
      "domainName": "string"
   }
}
```

## Response Elements
<a name="API_AssociateApi_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [apiAssociation](#API_AssociateApi_ResponseSyntax) **   <a name="appsync-AssociateApi-response-apiAssociation"></a>
The `ApiAssociation` object.  
Type: [ApiAssociation](API_ApiAssociation.md) object

## Errors
<a name="API_AssociateApi_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have access to perform this operation on this resource.  
HTTP Status Code: 403

 ** BadRequestException **   
The request is not well formed. For example, a value is invalid or a required field is missing. Check the field values, and then try again.    
 ** detail **   
Provides further details for the reason behind the bad request. For reason type `CODE_ERROR`, the detail will contain a list of code errors.  
 ** reason **   
Provides context for the cause of the bad request. The only supported value is `CODE_ERROR`.
HTTP Status Code: 400

 ** InternalFailureException **   
An internal AWS AppSync error occurred. Try your request again.  
HTTP Status Code: 500

 ** NotFoundException **   
The resource specified in the request was not found. Check the resource, and then try again.  
HTTP Status Code: 404

## See Also
<a name="API_AssociateApi_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/appsync-2017-07-25/AssociateApi) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/appsync-2017-07-25/AssociateApi) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/appsync-2017-07-25/AssociateApi) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/appsync-2017-07-25/AssociateApi) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/appsync-2017-07-25/AssociateApi) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/appsync-2017-07-25/AssociateApi) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/appsync-2017-07-25/AssociateApi) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/appsync-2017-07-25/AssociateApi) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/appsync-2017-07-25/AssociateApi) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/appsync-2017-07-25/AssociateApi) 

# AssociateMergedGraphqlApi
<a name="API_AssociateMergedGraphqlApi"></a>

Creates an association between a Merged API and source API using the source API's identifier.

## Request Syntax
<a name="API_AssociateMergedGraphqlApi_RequestSyntax"></a>

```
POST /v1/sourceApis/sourceApiIdentifier/mergedApiAssociations HTTP/1.1
Content-type: application/json

{
   "description": "string",
   "mergedApiIdentifier": "string",
   "sourceApiAssociationConfig": { 
      "mergeType": "string"
   }
}
```

## URI Request Parameters
<a name="API_AssociateMergedGraphqlApi_RequestParameters"></a>

The request uses the following URI parameters.

 ** [sourceApiIdentifier](#API_AssociateMergedGraphqlApi_RequestSyntax) **   <a name="appsync-AssociateMergedGraphqlApi-request-uri-sourceApiIdentifier"></a>
The identifier of the AppSync Source API. This is generated by the AppSync service. In most cases, source APIs (especially in your account) only require the API ID value or ARN of the source API. However, source APIs from other accounts (cross-account use cases) strictly require the full resource ARN of the source API.  
Required: Yes

## Request Body
<a name="API_AssociateMergedGraphqlApi_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [description](#API_AssociateMergedGraphqlApi_RequestSyntax) **   <a name="appsync-AssociateMergedGraphqlApi-request-description"></a>
The description field.  
Type: String  
Required: No

 ** [mergedApiIdentifier](#API_AssociateMergedGraphqlApi_RequestSyntax) **   <a name="appsync-AssociateMergedGraphqlApi-request-mergedApiIdentifier"></a>
The identifier of the AppSync Merged API. This is generated by the AppSync service. In most cases, Merged APIs (especially in your account) only require the API ID value or ARN of the merged API. However, Merged APIs in other accounts (cross-account use cases) strictly require the full resource ARN of the merged API.  
Type: String  
Required: Yes

 ** [sourceApiAssociationConfig](#API_AssociateMergedGraphqlApi_RequestSyntax) **   <a name="appsync-AssociateMergedGraphqlApi-request-sourceApiAssociationConfig"></a>
The `SourceApiAssociationConfig` object data.  
Type: [SourceApiAssociationConfig](API_SourceApiAssociationConfig.md) object  
Required: No

## Response Syntax
<a name="API_AssociateMergedGraphqlApi_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "sourceApiAssociation": { 
      "associationArn": "string",
      "associationId": "string",
      "description": "string",
      "lastSuccessfulMergeDate": number,
      "mergedApiArn": "string",
      "mergedApiId": "string",
      "sourceApiArn": "string",
      "sourceApiAssociationConfig": { 
         "mergeType": "string"
      },
      "sourceApiAssociationStatus": "string",
      "sourceApiAssociationStatusDetail": "string",
      "sourceApiId": "string"
   }
}
```

## Response Elements
<a name="API_AssociateMergedGraphqlApi_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [sourceApiAssociation](#API_AssociateMergedGraphqlApi_ResponseSyntax) **   <a name="appsync-AssociateMergedGraphqlApi-response-sourceApiAssociation"></a>
The `SourceApiAssociation` object data.  
Type: [SourceApiAssociation](API_SourceApiAssociation.md) object

## Errors
<a name="API_AssociateMergedGraphqlApi_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** BadRequestException **   
The request is not well formed. For example, a value is invalid or a required field is missing. Check the field values, and then try again.    
 ** detail **   
Provides further details for the reason behind the bad request. For reason type `CODE_ERROR`, the detail will contain a list of code errors.  
 ** reason **   
Provides context for the cause of the bad request. The only supported value is `CODE_ERROR`.
HTTP Status Code: 400

 ** ConcurrentModificationException **   
Another modification is in progress at this time and it must complete before you can make your change.  
HTTP Status Code: 409

 ** InternalFailureException **   
An internal AWS AppSync error occurred. Try your request again.  
HTTP Status Code: 500

 ** LimitExceededException **   
The request exceeded a limit. Try your request again.  
HTTP Status Code: 429

 ** NotFoundException **   
The resource specified in the request was not found. Check the resource, and then try again.  
HTTP Status Code: 404

 ** UnauthorizedException **   
You aren't authorized to perform this operation.  
HTTP Status Code: 401

## See Also
<a name="API_AssociateMergedGraphqlApi_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/appsync-2017-07-25/AssociateMergedGraphqlApi) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/appsync-2017-07-25/AssociateMergedGraphqlApi) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/appsync-2017-07-25/AssociateMergedGraphqlApi) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/appsync-2017-07-25/AssociateMergedGraphqlApi) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/appsync-2017-07-25/AssociateMergedGraphqlApi) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/appsync-2017-07-25/AssociateMergedGraphqlApi) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/appsync-2017-07-25/AssociateMergedGraphqlApi) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/appsync-2017-07-25/AssociateMergedGraphqlApi) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/appsync-2017-07-25/AssociateMergedGraphqlApi) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/appsync-2017-07-25/AssociateMergedGraphqlApi) 

# AssociateSourceGraphqlApi
<a name="API_AssociateSourceGraphqlApi"></a>

Creates an association between a Merged API and source API using the Merged API's identifier.

## Request Syntax
<a name="API_AssociateSourceGraphqlApi_RequestSyntax"></a>

```
POST /v1/mergedApis/mergedApiIdentifier/sourceApiAssociations HTTP/1.1
Content-type: application/json

{
   "description": "string",
   "sourceApiAssociationConfig": { 
      "mergeType": "string"
   },
   "sourceApiIdentifier": "string"
}
```

## URI Request Parameters
<a name="API_AssociateSourceGraphqlApi_RequestParameters"></a>

The request uses the following URI parameters.

 ** [mergedApiIdentifier](#API_AssociateSourceGraphqlApi_RequestSyntax) **   <a name="appsync-AssociateSourceGraphqlApi-request-uri-mergedApiIdentifier"></a>
The identifier of the AppSync Merged API. This is generated by the AppSync service. In most cases, Merged APIs (especially in your account) only require the API ID value or ARN of the merged API. However, Merged APIs in other accounts (cross-account use cases) strictly require the full resource ARN of the merged API.  
Required: Yes

## Request Body
<a name="API_AssociateSourceGraphqlApi_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [description](#API_AssociateSourceGraphqlApi_RequestSyntax) **   <a name="appsync-AssociateSourceGraphqlApi-request-description"></a>
The description field.  
Type: String  
Required: No

 ** [sourceApiAssociationConfig](#API_AssociateSourceGraphqlApi_RequestSyntax) **   <a name="appsync-AssociateSourceGraphqlApi-request-sourceApiAssociationConfig"></a>
The `SourceApiAssociationConfig` object data.  
Type: [SourceApiAssociationConfig](API_SourceApiAssociationConfig.md) object  
Required: No

 ** [sourceApiIdentifier](#API_AssociateSourceGraphqlApi_RequestSyntax) **   <a name="appsync-AssociateSourceGraphqlApi-request-sourceApiIdentifier"></a>
The identifier of the AppSync Source API. This is generated by the AppSync service. In most cases, source APIs (especially in your account) only require the API ID value or ARN of the source API. However, source APIs from other accounts (cross-account use cases) strictly require the full resource ARN of the source API.  
Type: String  
Required: Yes

## Response Syntax
<a name="API_AssociateSourceGraphqlApi_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "sourceApiAssociation": { 
      "associationArn": "string",
      "associationId": "string",
      "description": "string",
      "lastSuccessfulMergeDate": number,
      "mergedApiArn": "string",
      "mergedApiId": "string",
      "sourceApiArn": "string",
      "sourceApiAssociationConfig": { 
         "mergeType": "string"
      },
      "sourceApiAssociationStatus": "string",
      "sourceApiAssociationStatusDetail": "string",
      "sourceApiId": "string"
   }
}
```

## Response Elements
<a name="API_AssociateSourceGraphqlApi_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [sourceApiAssociation](#API_AssociateSourceGraphqlApi_ResponseSyntax) **   <a name="appsync-AssociateSourceGraphqlApi-response-sourceApiAssociation"></a>
The `SourceApiAssociation` object data.  
Type: [SourceApiAssociation](API_SourceApiAssociation.md) object

## Errors
<a name="API_AssociateSourceGraphqlApi_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** BadRequestException **   
The request is not well formed. For example, a value is invalid or a required field is missing. Check the field values, and then try again.    
 ** detail **   
Provides further details for the reason behind the bad request. For reason type `CODE_ERROR`, the detail will contain a list of code errors.  
 ** reason **   
Provides context for the cause of the bad request. The only supported value is `CODE_ERROR`.
HTTP Status Code: 400

 ** ConcurrentModificationException **   
Another modification is in progress at this time and it must complete before you can make your change.  
HTTP Status Code: 409

 ** InternalFailureException **   
An internal AWS AppSync error occurred. Try your request again.  
HTTP Status Code: 500

 ** LimitExceededException **   
The request exceeded a limit. Try your request again.  
HTTP Status Code: 429

 ** NotFoundException **   
The resource specified in the request was not found. Check the resource, and then try again.  
HTTP Status Code: 404

 ** UnauthorizedException **   
You aren't authorized to perform this operation.  
HTTP Status Code: 401

## See Also
<a name="API_AssociateSourceGraphqlApi_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/appsync-2017-07-25/AssociateSourceGraphqlApi) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/appsync-2017-07-25/AssociateSourceGraphqlApi) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/appsync-2017-07-25/AssociateSourceGraphqlApi) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/appsync-2017-07-25/AssociateSourceGraphqlApi) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/appsync-2017-07-25/AssociateSourceGraphqlApi) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/appsync-2017-07-25/AssociateSourceGraphqlApi) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/appsync-2017-07-25/AssociateSourceGraphqlApi) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/appsync-2017-07-25/AssociateSourceGraphqlApi) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/appsync-2017-07-25/AssociateSourceGraphqlApi) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/appsync-2017-07-25/AssociateSourceGraphqlApi) 

# CreateApi
<a name="API_CreateApi"></a>

Creates an `Api` object. Use this operation to create an AWS AppSync API with your preferred configuration, such as an Event API that provides real-time message publishing and message subscriptions over WebSockets.

## Request Syntax
<a name="API_CreateApi_RequestSyntax"></a>

```
POST /v2/apis HTTP/1.1
Content-type: application/json

{
   "eventConfig": { 
      "authProviders": [ 
         { 
            "authType": "string",
            "cognitoConfig": { 
               "appIdClientRegex": "string",
               "awsRegion": "string",
               "userPoolId": "string"
            },
            "lambdaAuthorizerConfig": { 
               "authorizerResultTtlInSeconds": number,
               "authorizerUri": "string",
               "identityValidationExpression": "string"
            },
            "openIDConnectConfig": { 
               "authTTL": number,
               "clientId": "string",
               "iatTTL": number,
               "issuer": "string"
            }
         }
      ],
      "connectionAuthModes": [ 
         { 
            "authType": "string"
         }
      ],
      "defaultPublishAuthModes": [ 
         { 
            "authType": "string"
         }
      ],
      "defaultSubscribeAuthModes": [ 
         { 
            "authType": "string"
         }
      ],
      "logConfig": { 
         "cloudWatchLogsRoleArn": "string",
         "logLevel": "string"
      }
   },
   "name": "string",
   "ownerContact": "string",
   "tags": { 
      "string" : "string" 
   }
}
```

## URI Request Parameters
<a name="API_CreateApi_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_CreateApi_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [eventConfig](#API_CreateApi_RequestSyntax) **   <a name="appsync-CreateApi-request-eventConfig"></a>
The Event API configuration. This includes the default authorization configuration for connecting, publishing, and subscribing to an Event API.  
Type: [EventConfig](API_EventConfig.md) object  
Required: No

 ** [name](#API_CreateApi_RequestSyntax) **   <a name="appsync-CreateApi-request-name"></a>
The name for the `Api`.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 50.  
Pattern: `[A-Za-z0-9_\-\ ]+`   
Required: Yes

 ** [ownerContact](#API_CreateApi_RequestSyntax) **   <a name="appsync-CreateApi-request-ownerContact"></a>
The owner contact information for the `Api`.  
Type: String  
Required: No

 ** [tags](#API_CreateApi_RequestSyntax) **   <a name="appsync-CreateApi-request-tags"></a>
A map with keys of `TagKey` objects and values of `TagValue` objects.  
Type: String to string map  
Map Entries: Maximum number of 50 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Key Pattern: `^(?!aws:)[ a-zA-Z+-=._:/]+$`   
Value Length Constraints: Maximum length of 256.  
Value Pattern: `^[\s\w+-=\.:/@]*$`   
Required: No

## Response Syntax
<a name="API_CreateApi_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "api": { 
      "apiArn": "string",
      "apiId": "string",
      "created": number,
      "dns": { 
         "string" : "string" 
      },
      "eventConfig": { 
         "authProviders": [ 
            { 
               "authType": "string",
               "cognitoConfig": { 
                  "appIdClientRegex": "string",
                  "awsRegion": "string",
                  "userPoolId": "string"
               },
               "lambdaAuthorizerConfig": { 
                  "authorizerResultTtlInSeconds": number,
                  "authorizerUri": "string",
                  "identityValidationExpression": "string"
               },
               "openIDConnectConfig": { 
                  "authTTL": number,
                  "clientId": "string",
                  "iatTTL": number,
                  "issuer": "string"
               }
            }
         ],
         "connectionAuthModes": [ 
            { 
               "authType": "string"
            }
         ],
         "defaultPublishAuthModes": [ 
            { 
               "authType": "string"
            }
         ],
         "defaultSubscribeAuthModes": [ 
            { 
               "authType": "string"
            }
         ],
         "logConfig": { 
            "cloudWatchLogsRoleArn": "string",
            "logLevel": "string"
         }
      },
      "name": "string",
      "ownerContact": "string",
      "tags": { 
         "string" : "string" 
      },
      "wafWebAclArn": "string",
      "xrayEnabled": boolean
   }
}
```

## Response Elements
<a name="API_CreateApi_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [api](#API_CreateApi_ResponseSyntax) **   <a name="appsync-CreateApi-response-api"></a>
The `Api` object.  
Type: [Api](API_Api.md) object

## Errors
<a name="API_CreateApi_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** BadRequestException **   
The request is not well formed. For example, a value is invalid or a required field is missing. Check the field values, and then try again.    
 ** detail **   
Provides further details for the reason behind the bad request. For reason type `CODE_ERROR`, the detail will contain a list of code errors.  
 ** reason **   
Provides context for the cause of the bad request. The only supported value is `CODE_ERROR`.
HTTP Status Code: 400

 ** ConcurrentModificationException **   
Another modification is in progress at this time and it must complete before you can make your change.  
HTTP Status Code: 409

 ** InternalFailureException **   
An internal AWS AppSync error occurred. Try your request again.  
HTTP Status Code: 500

 ** ServiceQuotaExceededException **   
The operation exceeded the service quota for this resource.  
HTTP Status Code: 402

 ** UnauthorizedException **   
You aren't authorized to perform this operation.  
HTTP Status Code: 401

## See Also
<a name="API_CreateApi_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/appsync-2017-07-25/CreateApi) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/appsync-2017-07-25/CreateApi) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/appsync-2017-07-25/CreateApi) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/appsync-2017-07-25/CreateApi) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/appsync-2017-07-25/CreateApi) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/appsync-2017-07-25/CreateApi) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/appsync-2017-07-25/CreateApi) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/appsync-2017-07-25/CreateApi) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/appsync-2017-07-25/CreateApi) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/appsync-2017-07-25/CreateApi) 

# CreateApiCache
<a name="API_CreateApiCache"></a>

Creates a cache for the GraphQL API.

## Request Syntax
<a name="API_CreateApiCache_RequestSyntax"></a>

```
POST /v1/apis/apiId/ApiCaches HTTP/1.1
Content-type: application/json

{
   "apiCachingBehavior": "string",
   "atRestEncryptionEnabled": boolean,
   "healthMetricsConfig": "string",
   "transitEncryptionEnabled": boolean,
   "ttl": number,
   "type": "string"
}
```

## URI Request Parameters
<a name="API_CreateApiCache_RequestParameters"></a>

The request uses the following URI parameters.

 ** [apiId](#API_CreateApiCache_RequestSyntax) **   <a name="appsync-CreateApiCache-request-uri-apiId"></a>
The GraphQL API ID.  
Required: Yes

## Request Body
<a name="API_CreateApiCache_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [apiCachingBehavior](#API_CreateApiCache_RequestSyntax) **   <a name="appsync-CreateApiCache-request-apiCachingBehavior"></a>
Caching behavior.  
+  **FULL\$1REQUEST\$1CACHING**: All requests from the same user are cached. Individual resolvers are automatically cached. All API calls will try to return responses from the cache.
+  **PER\$1RESOLVER\$1CACHING**: Individual resolvers that you specify are cached.
+  **OPERATION\$1LEVEL\$1CACHING**: Full requests are cached together and returned without executing resolvers.
Type: String  
Valid Values: `FULL_REQUEST_CACHING | PER_RESOLVER_CACHING | OPERATION_LEVEL_CACHING`   
Required: Yes

 ** [atRestEncryptionEnabled](#API_CreateApiCache_RequestSyntax) **   <a name="appsync-CreateApiCache-request-atRestEncryptionEnabled"></a>
 *This parameter has been deprecated.*   
At-rest encryption flag for cache. You cannot update this setting after creation.  
Type: Boolean  
Required: No

 ** [healthMetricsConfig](#API_CreateApiCache_RequestSyntax) **   <a name="appsync-CreateApiCache-request-healthMetricsConfig"></a>
Controls how cache health metrics will be emitted to CloudWatch. Cache health metrics include:  
+ NetworkBandwidthOutAllowanceExceeded: The network packets dropped because the throughput exceeded the aggregated bandwidth limit. This is useful for diagnosing bottlenecks in a cache configuration.
+ EngineCPUUtilization: The CPU utilization (percentage) allocated to the Redis process. This is useful for diagnosing bottlenecks in a cache configuration.
Metrics will be recorded by API ID. You can set the value to `ENABLED` or `DISABLED`.  
Type: String  
Valid Values: `ENABLED | DISABLED`   
Required: No

 ** [transitEncryptionEnabled](#API_CreateApiCache_RequestSyntax) **   <a name="appsync-CreateApiCache-request-transitEncryptionEnabled"></a>
 *This parameter has been deprecated.*   
Transit encryption flag when connecting to cache. You cannot update this setting after creation.  
Type: Boolean  
Required: No

 ** [ttl](#API_CreateApiCache_RequestSyntax) **   <a name="appsync-CreateApiCache-request-ttl"></a>
TTL in seconds for cache entries.  
Valid values are 1–3,600 seconds.  
Type: Long  
Required: Yes

 ** [type](#API_CreateApiCache_RequestSyntax) **   <a name="appsync-CreateApiCache-request-type"></a>
The cache instance type. Valid values are   
+  `SMALL` 
+  `MEDIUM` 
+  `LARGE` 
+  `XLARGE` 
+  `LARGE_2X` 
+  `LARGE_4X` 
+  `LARGE_8X` (not available in all regions)
+  `LARGE_12X` 
Historically, instance types were identified by an EC2-style value. As of July 2020, this is deprecated, and the generic identifiers above should be used.  
The following legacy instance types are available, but their use is discouraged:  
+  **T2\$1SMALL**: A t2.small instance type.
+  **T2\$1MEDIUM**: A t2.medium instance type.
+  **R4\$1LARGE**: A r4.large instance type.
+  **R4\$1XLARGE**: A r4.xlarge instance type.
+  **R4\$12XLARGE**: A r4.2xlarge instance type.
+  **R4\$14XLARGE**: A r4.4xlarge instance type.
+  **R4\$18XLARGE**: A r4.8xlarge instance type.
Type: String  
Valid Values: `T2_SMALL | T2_MEDIUM | R4_LARGE | R4_XLARGE | R4_2XLARGE | R4_4XLARGE | R4_8XLARGE | SMALL | MEDIUM | LARGE | XLARGE | LARGE_2X | LARGE_4X | LARGE_8X | LARGE_12X`   
Required: Yes

## Response Syntax
<a name="API_CreateApiCache_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "apiCache": { 
      "apiCachingBehavior": "string",
      "atRestEncryptionEnabled": boolean,
      "healthMetricsConfig": "string",
      "status": "string",
      "transitEncryptionEnabled": boolean,
      "ttl": number,
      "type": "string"
   }
}
```

## Response Elements
<a name="API_CreateApiCache_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [apiCache](#API_CreateApiCache_ResponseSyntax) **   <a name="appsync-CreateApiCache-response-apiCache"></a>
The `ApiCache` object.  
Type: [ApiCache](API_ApiCache.md) object

## Errors
<a name="API_CreateApiCache_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** BadRequestException **   
The request is not well formed. For example, a value is invalid or a required field is missing. Check the field values, and then try again.    
 ** detail **   
Provides further details for the reason behind the bad request. For reason type `CODE_ERROR`, the detail will contain a list of code errors.  
 ** reason **   
Provides context for the cause of the bad request. The only supported value is `CODE_ERROR`.
HTTP Status Code: 400

 ** ConcurrentModificationException **   
Another modification is in progress at this time and it must complete before you can make your change.  
HTTP Status Code: 409

 ** InternalFailureException **   
An internal AWS AppSync error occurred. Try your request again.  
HTTP Status Code: 500

 ** NotFoundException **   
The resource specified in the request was not found. Check the resource, and then try again.  
HTTP Status Code: 404

 ** UnauthorizedException **   
You aren't authorized to perform this operation.  
HTTP Status Code: 401

## See Also
<a name="API_CreateApiCache_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/appsync-2017-07-25/CreateApiCache) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/appsync-2017-07-25/CreateApiCache) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/appsync-2017-07-25/CreateApiCache) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/appsync-2017-07-25/CreateApiCache) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/appsync-2017-07-25/CreateApiCache) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/appsync-2017-07-25/CreateApiCache) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/appsync-2017-07-25/CreateApiCache) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/appsync-2017-07-25/CreateApiCache) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/appsync-2017-07-25/CreateApiCache) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/appsync-2017-07-25/CreateApiCache) 

# CreateApiKey
<a name="API_CreateApiKey"></a>

Creates a unique key that you can distribute to clients who invoke your API.

## Request Syntax
<a name="API_CreateApiKey_RequestSyntax"></a>

```
POST /v1/apis/apiId/apikeys HTTP/1.1
Content-type: application/json

{
   "description": "string",
   "expires": number
}
```

## URI Request Parameters
<a name="API_CreateApiKey_RequestParameters"></a>

The request uses the following URI parameters.

 ** [apiId](#API_CreateApiKey_RequestSyntax) **   <a name="appsync-CreateApiKey-request-uri-apiId"></a>
The ID for your GraphQL API.  
Required: Yes

## Request Body
<a name="API_CreateApiKey_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [description](#API_CreateApiKey_RequestSyntax) **   <a name="appsync-CreateApiKey-request-description"></a>
A description of the purpose of the API key.  
Type: String  
Required: No

 ** [expires](#API_CreateApiKey_RequestSyntax) **   <a name="appsync-CreateApiKey-request-expires"></a>
From the creation time, the time after which the API key expires. The date is represented as seconds since the epoch, rounded down to the nearest hour. The default value for this parameter is 7 days from creation time. For more information, see [ApiKey](API_ApiKey.md).  
Type: Long  
Required: No

## Response Syntax
<a name="API_CreateApiKey_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "apiKey": { 
      "deletes": number,
      "description": "string",
      "expires": number,
      "id": "string"
   }
}
```

## Response Elements
<a name="API_CreateApiKey_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [apiKey](#API_CreateApiKey_ResponseSyntax) **   <a name="appsync-CreateApiKey-response-apiKey"></a>
The API key.  
Type: [ApiKey](API_ApiKey.md) object

## Errors
<a name="API_CreateApiKey_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** ApiKeyLimitExceededException **   
The API key exceeded a limit. Try your request again.  
HTTP Status Code: 400

 ** ApiKeyValidityOutOfBoundsException **   
The API key expiration must be set to a value between 1 and 365 days from creation (for `CreateApiKey`) or from update (for `UpdateApiKey`).  
HTTP Status Code: 400

 ** BadRequestException **   
The request is not well formed. For example, a value is invalid or a required field is missing. Check the field values, and then try again.    
 ** detail **   
Provides further details for the reason behind the bad request. For reason type `CODE_ERROR`, the detail will contain a list of code errors.  
 ** reason **   
Provides context for the cause of the bad request. The only supported value is `CODE_ERROR`.
HTTP Status Code: 400

 ** InternalFailureException **   
An internal AWS AppSync error occurred. Try your request again.  
HTTP Status Code: 500

 ** LimitExceededException **   
The request exceeded a limit. Try your request again.  
HTTP Status Code: 429

 ** LimitExceededException **   
The request exceeded a limit. Try your request again.  
HTTP Status Code: 429

 ** NotFoundException **   
The resource specified in the request was not found. Check the resource, and then try again.  
HTTP Status Code: 404

 ** UnauthorizedException **   
You aren't authorized to perform this operation.  
HTTP Status Code: 401

## See Also
<a name="API_CreateApiKey_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/appsync-2017-07-25/CreateApiKey) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/appsync-2017-07-25/CreateApiKey) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/appsync-2017-07-25/CreateApiKey) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/appsync-2017-07-25/CreateApiKey) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/appsync-2017-07-25/CreateApiKey) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/appsync-2017-07-25/CreateApiKey) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/appsync-2017-07-25/CreateApiKey) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/appsync-2017-07-25/CreateApiKey) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/appsync-2017-07-25/CreateApiKey) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/appsync-2017-07-25/CreateApiKey) 

# CreateChannelNamespace
<a name="API_CreateChannelNamespace"></a>

Creates a `ChannelNamespace` for an `Api`.

## Request Syntax
<a name="API_CreateChannelNamespace_RequestSyntax"></a>

```
POST /v2/apis/apiId/channelNamespaces HTTP/1.1
Content-type: application/json

{
   "codeHandlers": "string",
   "handlerConfigs": { 
      "onPublish": { 
         "behavior": "string",
         "integration": { 
            "dataSourceName": "string",
            "lambdaConfig": { 
               "invokeType": "string"
            }
         }
      },
      "onSubscribe": { 
         "behavior": "string",
         "integration": { 
            "dataSourceName": "string",
            "lambdaConfig": { 
               "invokeType": "string"
            }
         }
      }
   },
   "name": "string",
   "publishAuthModes": [ 
      { 
         "authType": "string"
      }
   ],
   "subscribeAuthModes": [ 
      { 
         "authType": "string"
      }
   ],
   "tags": { 
      "string" : "string" 
   }
}
```

## URI Request Parameters
<a name="API_CreateChannelNamespace_RequestParameters"></a>

The request uses the following URI parameters.

 ** [apiId](#API_CreateChannelNamespace_RequestSyntax) **   <a name="appsync-CreateChannelNamespace-request-uri-apiId"></a>
The `Api` ID.  
Required: Yes

## Request Body
<a name="API_CreateChannelNamespace_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [codeHandlers](#API_CreateChannelNamespace_RequestSyntax) **   <a name="appsync-CreateChannelNamespace-request-codeHandlers"></a>
The event handler functions that run custom business logic to process published events and subscribe requests.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 32768.  
Required: No

 ** [handlerConfigs](#API_CreateChannelNamespace_RequestSyntax) **   <a name="appsync-CreateChannelNamespace-request-handlerConfigs"></a>
The configuration for the `OnPublish` and `OnSubscribe` handlers.  
Type: [HandlerConfigs](API_HandlerConfigs.md) object  
Required: No

 ** [name](#API_CreateChannelNamespace_RequestSyntax) **   <a name="appsync-CreateChannelNamespace-request-name"></a>
The name of the `ChannelNamespace`. This name must be unique within the `Api`   
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 50.  
Pattern: `([A-Za-z0-9](?:[A-Za-z0-9\-]{0,48}[A-Za-z0-9])?)`   
Required: Yes

 ** [publishAuthModes](#API_CreateChannelNamespace_RequestSyntax) **   <a name="appsync-CreateChannelNamespace-request-publishAuthModes"></a>
The authorization mode to use for publishing messages on the channel namespace. This configuration overrides the default `Api` authorization configuration.  
Type: Array of [AuthMode](API_AuthMode.md) objects  
Required: No

 ** [subscribeAuthModes](#API_CreateChannelNamespace_RequestSyntax) **   <a name="appsync-CreateChannelNamespace-request-subscribeAuthModes"></a>
The authorization mode to use for subscribing to messages on the channel namespace. This configuration overrides the default `Api` authorization configuration.  
Type: Array of [AuthMode](API_AuthMode.md) objects  
Required: No

 ** [tags](#API_CreateChannelNamespace_RequestSyntax) **   <a name="appsync-CreateChannelNamespace-request-tags"></a>
A map with keys of `TagKey` objects and values of `TagValue` objects.  
Type: String to string map  
Map Entries: Maximum number of 50 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Key Pattern: `^(?!aws:)[ a-zA-Z+-=._:/]+$`   
Value Length Constraints: Maximum length of 256.  
Value Pattern: `^[\s\w+-=\.:/@]*$`   
Required: No

## Response Syntax
<a name="API_CreateChannelNamespace_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "channelNamespace": { 
      "apiId": "string",
      "channelNamespaceArn": "string",
      "codeHandlers": "string",
      "created": number,
      "handlerConfigs": { 
         "onPublish": { 
            "behavior": "string",
            "integration": { 
               "dataSourceName": "string",
               "lambdaConfig": { 
                  "invokeType": "string"
               }
            }
         },
         "onSubscribe": { 
            "behavior": "string",
            "integration": { 
               "dataSourceName": "string",
               "lambdaConfig": { 
                  "invokeType": "string"
               }
            }
         }
      },
      "lastModified": number,
      "name": "string",
      "publishAuthModes": [ 
         { 
            "authType": "string"
         }
      ],
      "subscribeAuthModes": [ 
         { 
            "authType": "string"
         }
      ],
      "tags": { 
         "string" : "string" 
      }
   }
}
```

## Response Elements
<a name="API_CreateChannelNamespace_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [channelNamespace](#API_CreateChannelNamespace_ResponseSyntax) **   <a name="appsync-CreateChannelNamespace-response-channelNamespace"></a>
The `ChannelNamespace` object.  
Type: [ChannelNamespace](API_ChannelNamespace.md) object

## Errors
<a name="API_CreateChannelNamespace_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** BadRequestException **   
The request is not well formed. For example, a value is invalid or a required field is missing. Check the field values, and then try again.    
 ** detail **   
Provides further details for the reason behind the bad request. For reason type `CODE_ERROR`, the detail will contain a list of code errors.  
 ** reason **   
Provides context for the cause of the bad request. The only supported value is `CODE_ERROR`.
HTTP Status Code: 400

 ** ConcurrentModificationException **   
Another modification is in progress at this time and it must complete before you can make your change.  
HTTP Status Code: 409

 ** ConflictException **   
A conflict with a previous successful update is detected. This typically occurs when the previous update did not have time to propagate before the next update was made. A retry (with appropriate backoff logic) is the recommended response to this exception.  
HTTP Status Code: 409

 ** InternalFailureException **   
An internal AWS AppSync error occurred. Try your request again.  
HTTP Status Code: 500

 ** NotFoundException **   
The resource specified in the request was not found. Check the resource, and then try again.  
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
The operation exceeded the service quota for this resource.  
HTTP Status Code: 402

 ** UnauthorizedException **   
You aren't authorized to perform this operation.  
HTTP Status Code: 401

## See Also
<a name="API_CreateChannelNamespace_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/appsync-2017-07-25/CreateChannelNamespace) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/appsync-2017-07-25/CreateChannelNamespace) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/appsync-2017-07-25/CreateChannelNamespace) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/appsync-2017-07-25/CreateChannelNamespace) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/appsync-2017-07-25/CreateChannelNamespace) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/appsync-2017-07-25/CreateChannelNamespace) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/appsync-2017-07-25/CreateChannelNamespace) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/appsync-2017-07-25/CreateChannelNamespace) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/appsync-2017-07-25/CreateChannelNamespace) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/appsync-2017-07-25/CreateChannelNamespace) 

# CreateDataSource
<a name="API_CreateDataSource"></a>

Creates a `DataSource` object.

## Request Syntax
<a name="API_CreateDataSource_RequestSyntax"></a>

```
POST /v1/apis/apiId/datasources HTTP/1.1
Content-type: application/json

{
   "description": "string",
   "dynamodbConfig": { 
      "awsRegion": "string",
      "deltaSyncConfig": { 
         "baseTableTTL": number,
         "deltaSyncTableName": "string",
         "deltaSyncTableTTL": number
      },
      "tableName": "string",
      "useCallerCredentials": boolean,
      "versioned": boolean
   },
   "elasticsearchConfig": { 
      "awsRegion": "string",
      "endpoint": "string"
   },
   "eventBridgeConfig": { 
      "eventBusArn": "string"
   },
   "httpConfig": { 
      "authorizationConfig": { 
         "authorizationType": "string",
         "awsIamConfig": { 
            "signingRegion": "string",
            "signingServiceName": "string"
         }
      },
      "endpoint": "string"
   },
   "lambdaConfig": { 
      "lambdaFunctionArn": "string"
   },
   "metricsConfig": "string",
   "name": "string",
   "openSearchServiceConfig": { 
      "awsRegion": "string",
      "endpoint": "string"
   },
   "relationalDatabaseConfig": { 
      "rdsHttpEndpointConfig": { 
         "awsRegion": "string",
         "awsSecretStoreArn": "string",
         "databaseName": "string",
         "dbClusterIdentifier": "string",
         "schema": "string"
      },
      "relationalDatabaseSourceType": "string"
   },
   "serviceRoleArn": "string",
   "type": "string"
}
```

## URI Request Parameters
<a name="API_CreateDataSource_RequestParameters"></a>

The request uses the following URI parameters.

 ** [apiId](#API_CreateDataSource_RequestSyntax) **   <a name="appsync-CreateDataSource-request-uri-apiId"></a>
The API ID for the GraphQL API for the `DataSource`.  
Required: Yes

## Request Body
<a name="API_CreateDataSource_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [description](#API_CreateDataSource_RequestSyntax) **   <a name="appsync-CreateDataSource-request-description"></a>
A description of the `DataSource`.  
Type: String  
Required: No

 ** [dynamodbConfig](#API_CreateDataSource_RequestSyntax) **   <a name="appsync-CreateDataSource-request-dynamodbConfig"></a>
Amazon DynamoDB settings.  
Type: [DynamodbDataSourceConfig](API_DynamodbDataSourceConfig.md) object  
Required: No

 ** [elasticsearchConfig](#API_CreateDataSource_RequestSyntax) **   <a name="appsync-CreateDataSource-request-elasticsearchConfig"></a>
Amazon OpenSearch Service settings.  
As of September 2021, Amazon Elasticsearch service is Amazon OpenSearch Service. This configuration is deprecated. For new data sources, use [CreateDataSource:openSearchServiceConfig](#appsync-CreateDataSource-request-openSearchServiceConfig) to create an OpenSearch data source.  
Type: [ElasticsearchDataSourceConfig](API_ElasticsearchDataSourceConfig.md) object  
Required: No

 ** [eventBridgeConfig](#API_CreateDataSource_RequestSyntax) **   <a name="appsync-CreateDataSource-request-eventBridgeConfig"></a>
Amazon EventBridge settings.  
Type: [EventBridgeDataSourceConfig](API_EventBridgeDataSourceConfig.md) object  
Required: No

 ** [httpConfig](#API_CreateDataSource_RequestSyntax) **   <a name="appsync-CreateDataSource-request-httpConfig"></a>
HTTP endpoint settings.  
Type: [HttpDataSourceConfig](API_HttpDataSourceConfig.md) object  
Required: No

 ** [lambdaConfig](#API_CreateDataSource_RequestSyntax) **   <a name="appsync-CreateDataSource-request-lambdaConfig"></a>
 AWS Lambda settings.  
Type: [LambdaDataSourceConfig](API_LambdaDataSourceConfig.md) object  
Required: No

 ** [metricsConfig](#API_CreateDataSource_RequestSyntax) **   <a name="appsync-CreateDataSource-request-metricsConfig"></a>
Enables or disables enhanced data source metrics for specified data sources. Note that `metricsConfig` won't be used unless the `dataSourceLevelMetricsBehavior` value is set to `PER_DATA_SOURCE_METRICS`. If the `dataSourceLevelMetricsBehavior` is set to `FULL_REQUEST_DATA_SOURCE_METRICS` instead, `metricsConfig` will be ignored. However, you can still set its value.  
 `metricsConfig` can be `ENABLED` or `DISABLED`.  
Type: String  
Valid Values: `ENABLED | DISABLED`   
Required: No

 ** [name](#API_CreateDataSource_RequestSyntax) **   <a name="appsync-CreateDataSource-request-name"></a>
A user-supplied name for the `DataSource`.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 65536.  
Pattern: `[_A-Za-z][_0-9A-Za-z]*`   
Required: Yes

 ** [openSearchServiceConfig](#API_CreateDataSource_RequestSyntax) **   <a name="appsync-CreateDataSource-request-openSearchServiceConfig"></a>
Amazon OpenSearch Service settings.  
Type: [OpenSearchServiceDataSourceConfig](API_OpenSearchServiceDataSourceConfig.md) object  
Required: No

 ** [relationalDatabaseConfig](#API_CreateDataSource_RequestSyntax) **   <a name="appsync-CreateDataSource-request-relationalDatabaseConfig"></a>
Relational database settings.  
Type: [RelationalDatabaseDataSourceConfig](API_RelationalDatabaseDataSourceConfig.md) object  
Required: No

 ** [serviceRoleArn](#API_CreateDataSource_RequestSyntax) **   <a name="appsync-CreateDataSource-request-serviceRoleArn"></a>
The AWS Identity and Access Management (IAM) service role Amazon Resource Name (ARN) for the data source. The system assumes this role when accessing the data source.  
Type: String  
Required: No

 ** [type](#API_CreateDataSource_RequestSyntax) **   <a name="appsync-CreateDataSource-request-type"></a>
The type of the `DataSource`.  
Type: String  
Valid Values: `AWS_LAMBDA | AMAZON_DYNAMODB | AMAZON_ELASTICSEARCH | NONE | HTTP | RELATIONAL_DATABASE | AMAZON_OPENSEARCH_SERVICE | AMAZON_EVENTBRIDGE | AMAZON_BEDROCK_RUNTIME`   
Required: Yes

## Response Syntax
<a name="API_CreateDataSource_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "dataSource": { 
      "dataSourceArn": "string",
      "description": "string",
      "dynamodbConfig": { 
         "awsRegion": "string",
         "deltaSyncConfig": { 
            "baseTableTTL": number,
            "deltaSyncTableName": "string",
            "deltaSyncTableTTL": number
         },
         "tableName": "string",
         "useCallerCredentials": boolean,
         "versioned": boolean
      },
      "elasticsearchConfig": { 
         "awsRegion": "string",
         "endpoint": "string"
      },
      "eventBridgeConfig": { 
         "eventBusArn": "string"
      },
      "httpConfig": { 
         "authorizationConfig": { 
            "authorizationType": "string",
            "awsIamConfig": { 
               "signingRegion": "string",
               "signingServiceName": "string"
            }
         },
         "endpoint": "string"
      },
      "lambdaConfig": { 
         "lambdaFunctionArn": "string"
      },
      "metricsConfig": "string",
      "name": "string",
      "openSearchServiceConfig": { 
         "awsRegion": "string",
         "endpoint": "string"
      },
      "relationalDatabaseConfig": { 
         "rdsHttpEndpointConfig": { 
            "awsRegion": "string",
            "awsSecretStoreArn": "string",
            "databaseName": "string",
            "dbClusterIdentifier": "string",
            "schema": "string"
         },
         "relationalDatabaseSourceType": "string"
      },
      "serviceRoleArn": "string",
      "type": "string"
   }
}
```

## Response Elements
<a name="API_CreateDataSource_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [dataSource](#API_CreateDataSource_ResponseSyntax) **   <a name="appsync-CreateDataSource-response-dataSource"></a>
The `DataSource` object.  
Type: [DataSource](API_DataSource.md) object

## Errors
<a name="API_CreateDataSource_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** BadRequestException **   
The request is not well formed. For example, a value is invalid or a required field is missing. Check the field values, and then try again.    
 ** detail **   
Provides further details for the reason behind the bad request. For reason type `CODE_ERROR`, the detail will contain a list of code errors.  
 ** reason **   
Provides context for the cause of the bad request. The only supported value is `CODE_ERROR`.
HTTP Status Code: 400

 ** ConcurrentModificationException **   
Another modification is in progress at this time and it must complete before you can make your change.  
HTTP Status Code: 409

 ** InternalFailureException **   
An internal AWS AppSync error occurred. Try your request again.  
HTTP Status Code: 500

 ** NotFoundException **   
The resource specified in the request was not found. Check the resource, and then try again.  
HTTP Status Code: 404

 ** UnauthorizedException **   
You aren't authorized to perform this operation.  
HTTP Status Code: 401

## See Also
<a name="API_CreateDataSource_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/appsync-2017-07-25/CreateDataSource) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/appsync-2017-07-25/CreateDataSource) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/appsync-2017-07-25/CreateDataSource) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/appsync-2017-07-25/CreateDataSource) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/appsync-2017-07-25/CreateDataSource) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/appsync-2017-07-25/CreateDataSource) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/appsync-2017-07-25/CreateDataSource) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/appsync-2017-07-25/CreateDataSource) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/appsync-2017-07-25/CreateDataSource) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/appsync-2017-07-25/CreateDataSource) 

# CreateDomainName
<a name="API_CreateDomainName"></a>

Creates a custom `DomainName` object.

## Request Syntax
<a name="API_CreateDomainName_RequestSyntax"></a>

```
POST /v1/domainnames HTTP/1.1
Content-type: application/json

{
   "certificateArn": "string",
   "description": "string",
   "domainName": "string",
   "tags": { 
      "string" : "string" 
   }
}
```

## URI Request Parameters
<a name="API_CreateDomainName_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_CreateDomainName_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [certificateArn](#API_CreateDomainName_RequestSyntax) **   <a name="appsync-CreateDomainName-request-certificateArn"></a>
The Amazon Resource Name (ARN) of the certificate. This can be an AWS Certificate Manager (ACM) certificate or an AWS Identity and Access Management (IAM) server certificate.  
Type: String  
Length Constraints: Minimum length of 20. Maximum length of 2048.  
Pattern: `^arn:[a-z-]*:(acm|iam):[a-z0-9-]*:\d{12}:(certificate|server-certificate)/[0-9A-Za-z_/-]*$`   
Required: Yes

 ** [description](#API_CreateDomainName_RequestSyntax) **   <a name="appsync-CreateDomainName-request-description"></a>
A description of the `DomainName`.  
Type: String  
Length Constraints: Minimum length of 0. Maximum length of 255.  
Pattern: `^.*$`   
Required: No

 ** [domainName](#API_CreateDomainName_RequestSyntax) **   <a name="appsync-CreateDomainName-request-domainName"></a>
The domain name.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 253.  
Pattern: `^(\*[\w\d-]*\.)?([\w\d-]+\.)+[\w\d-]+$`   
Required: Yes

 ** [tags](#API_CreateDomainName_RequestSyntax) **   <a name="appsync-CreateDomainName-request-tags"></a>
A map with keys of `TagKey` objects and values of `TagValue` objects.  
Type: String to string map  
Map Entries: Maximum number of 50 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Key Pattern: `^(?!aws:)[ a-zA-Z+-=._:/]+$`   
Value Length Constraints: Maximum length of 256.  
Value Pattern: `^[\s\w+-=\.:/@]*$`   
Required: No

## Response Syntax
<a name="API_CreateDomainName_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "domainNameConfig": { 
      "appsyncDomainName": "string",
      "certificateArn": "string",
      "description": "string",
      "domainName": "string",
      "domainNameArn": "string",
      "hostedZoneId": "string",
      "tags": { 
         "string" : "string" 
      }
   }
}
```

## Response Elements
<a name="API_CreateDomainName_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [domainNameConfig](#API_CreateDomainName_ResponseSyntax) **   <a name="appsync-CreateDomainName-response-domainNameConfig"></a>
The configuration for the `DomainName`.  
Type: [DomainNameConfig](API_DomainNameConfig.md) object

## Errors
<a name="API_CreateDomainName_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have access to perform this operation on this resource.  
HTTP Status Code: 403

 ** BadRequestException **   
The request is not well formed. For example, a value is invalid or a required field is missing. Check the field values, and then try again.    
 ** detail **   
Provides further details for the reason behind the bad request. For reason type `CODE_ERROR`, the detail will contain a list of code errors.  
 ** reason **   
Provides context for the cause of the bad request. The only supported value is `CODE_ERROR`.
HTTP Status Code: 400

 ** InternalFailureException **   
An internal AWS AppSync error occurred. Try your request again.  
HTTP Status Code: 500

## See Also
<a name="API_CreateDomainName_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/appsync-2017-07-25/CreateDomainName) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/appsync-2017-07-25/CreateDomainName) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/appsync-2017-07-25/CreateDomainName) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/appsync-2017-07-25/CreateDomainName) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/appsync-2017-07-25/CreateDomainName) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/appsync-2017-07-25/CreateDomainName) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/appsync-2017-07-25/CreateDomainName) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/appsync-2017-07-25/CreateDomainName) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/appsync-2017-07-25/CreateDomainName) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/appsync-2017-07-25/CreateDomainName) 

# CreateFunction
<a name="API_CreateFunction"></a>

Creates a `Function` object.

A function is a reusable entity. You can use multiple functions to compose the resolver logic.

## Request Syntax
<a name="API_CreateFunction_RequestSyntax"></a>

```
POST /v1/apis/apiId/functions HTTP/1.1
Content-type: application/json

{
   "code": "string",
   "dataSourceName": "string",
   "description": "string",
   "functionVersion": "string",
   "maxBatchSize": number,
   "name": "string",
   "requestMappingTemplate": "string",
   "responseMappingTemplate": "string",
   "runtime": { 
      "name": "string",
      "runtimeVersion": "string"
   },
   "syncConfig": { 
      "conflictDetection": "string",
      "conflictHandler": "string",
      "lambdaConflictHandlerConfig": { 
         "lambdaConflictHandlerArn": "string"
      }
   }
}
```

## URI Request Parameters
<a name="API_CreateFunction_RequestParameters"></a>

The request uses the following URI parameters.

 ** [apiId](#API_CreateFunction_RequestSyntax) **   <a name="appsync-CreateFunction-request-uri-apiId"></a>
The GraphQL API ID.  
Required: Yes

## Request Body
<a name="API_CreateFunction_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [code](#API_CreateFunction_RequestSyntax) **   <a name="appsync-CreateFunction-request-code"></a>
The `function` code that contains the request and response functions. When code is used, the `runtime` is required. The `runtime` value must be `APPSYNC_JS`.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 32768.  
Required: No

 ** [dataSourceName](#API_CreateFunction_RequestSyntax) **   <a name="appsync-CreateFunction-request-dataSourceName"></a>
The `Function` `DataSource` name.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 65536.  
Pattern: `[_A-Za-z][_0-9A-Za-z]*`   
Required: Yes

 ** [description](#API_CreateFunction_RequestSyntax) **   <a name="appsync-CreateFunction-request-description"></a>
The `Function` description.  
Type: String  
Required: No

 ** [functionVersion](#API_CreateFunction_RequestSyntax) **   <a name="appsync-CreateFunction-request-functionVersion"></a>
The `version` of the request mapping template. Currently, the supported value is 2018-05-29. Note that when using VTL and mapping templates, the `functionVersion` is required.  
Type: String  
Required: No

 ** [maxBatchSize](#API_CreateFunction_RequestSyntax) **   <a name="appsync-CreateFunction-request-maxBatchSize"></a>
The maximum batching size for a resolver.  
Type: Integer  
Valid Range: Minimum value of 0. Maximum value of 2000.  
Required: No

 ** [name](#API_CreateFunction_RequestSyntax) **   <a name="appsync-CreateFunction-request-name"></a>
The `Function` name. The function name does not have to be unique.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 65536.  
Pattern: `[_A-Za-z][_0-9A-Za-z]*`   
Required: Yes

 ** [requestMappingTemplate](#API_CreateFunction_RequestSyntax) **   <a name="appsync-CreateFunction-request-requestMappingTemplate"></a>
The `Function` request mapping template. Functions support only the 2018-05-29 version of the request mapping template.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 65536.  
Pattern: `^.*$`   
Required: No

 ** [responseMappingTemplate](#API_CreateFunction_RequestSyntax) **   <a name="appsync-CreateFunction-request-responseMappingTemplate"></a>
The `Function` response mapping template.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 65536.  
Pattern: `^.*$`   
Required: No

 ** [runtime](#API_CreateFunction_RequestSyntax) **   <a name="appsync-CreateFunction-request-runtime"></a>
Describes a runtime used by an AWS AppSync pipeline resolver or AWS AppSync function. Specifies the name and version of the runtime to use. Note that if a runtime is specified, code must also be specified.  
Type: [AppSyncRuntime](API_AppSyncRuntime.md) object  
Required: No

 ** [syncConfig](#API_CreateFunction_RequestSyntax) **   <a name="appsync-CreateFunction-request-syncConfig"></a>
Describes a Sync configuration for a resolver.  
Specifies which Conflict Detection strategy and Resolution strategy to use when the resolver is invoked.  
Type: [SyncConfig](API_SyncConfig.md) object  
Required: No

## Response Syntax
<a name="API_CreateFunction_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "functionConfiguration": { 
      "code": "string",
      "dataSourceName": "string",
      "description": "string",
      "functionArn": "string",
      "functionId": "string",
      "functionVersion": "string",
      "maxBatchSize": number,
      "name": "string",
      "requestMappingTemplate": "string",
      "responseMappingTemplate": "string",
      "runtime": { 
         "name": "string",
         "runtimeVersion": "string"
      },
      "syncConfig": { 
         "conflictDetection": "string",
         "conflictHandler": "string",
         "lambdaConflictHandlerConfig": { 
            "lambdaConflictHandlerArn": "string"
         }
      }
   }
}
```

## Response Elements
<a name="API_CreateFunction_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [functionConfiguration](#API_CreateFunction_ResponseSyntax) **   <a name="appsync-CreateFunction-response-functionConfiguration"></a>
The `Function` object.  
Type: [FunctionConfiguration](API_FunctionConfiguration.md) object

## Errors
<a name="API_CreateFunction_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** BadRequestException **   
The request is not well formed. For example, a value is invalid or a required field is missing. Check the field values, and then try again.    
 ** detail **   
Provides further details for the reason behind the bad request. For reason type `CODE_ERROR`, the detail will contain a list of code errors.  
 ** reason **   
Provides context for the cause of the bad request. The only supported value is `CODE_ERROR`.
HTTP Status Code: 400

 ** ConcurrentModificationException **   
Another modification is in progress at this time and it must complete before you can make your change.  
HTTP Status Code: 409

 ** InternalFailureException **   
An internal AWS AppSync error occurred. Try your request again.  
HTTP Status Code: 500

 ** NotFoundException **   
The resource specified in the request was not found. Check the resource, and then try again.  
HTTP Status Code: 404

 ** UnauthorizedException **   
You aren't authorized to perform this operation.  
HTTP Status Code: 401

## See Also
<a name="API_CreateFunction_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/appsync-2017-07-25/CreateFunction) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/appsync-2017-07-25/CreateFunction) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/appsync-2017-07-25/CreateFunction) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/appsync-2017-07-25/CreateFunction) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/appsync-2017-07-25/CreateFunction) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/appsync-2017-07-25/CreateFunction) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/appsync-2017-07-25/CreateFunction) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/appsync-2017-07-25/CreateFunction) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/appsync-2017-07-25/CreateFunction) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/appsync-2017-07-25/CreateFunction) 

# CreateGraphqlApi
<a name="API_CreateGraphqlApi"></a>

Creates a `GraphqlApi` object.

## Request Syntax
<a name="API_CreateGraphqlApi_RequestSyntax"></a>

```
POST /v1/apis HTTP/1.1
Content-type: application/json

{
   "additionalAuthenticationProviders": [ 
      { 
         "authenticationType": "string",
         "lambdaAuthorizerConfig": { 
            "authorizerResultTtlInSeconds": number,
            "authorizerUri": "string",
            "identityValidationExpression": "string"
         },
         "openIDConnectConfig": { 
            "authTTL": number,
            "clientId": "string",
            "iatTTL": number,
            "issuer": "string"
         },
         "userPoolConfig": { 
            "appIdClientRegex": "string",
            "awsRegion": "string",
            "userPoolId": "string"
         }
      }
   ],
   "apiType": "string",
   "authenticationType": "string",
   "enhancedMetricsConfig": { 
      "dataSourceLevelMetricsBehavior": "string",
      "operationLevelMetricsConfig": "string",
      "resolverLevelMetricsBehavior": "string"
   },
   "introspectionConfig": "string",
   "lambdaAuthorizerConfig": { 
      "authorizerResultTtlInSeconds": number,
      "authorizerUri": "string",
      "identityValidationExpression": "string"
   },
   "logConfig": { 
      "cloudWatchLogsRoleArn": "string",
      "excludeVerboseContent": boolean,
      "fieldLogLevel": "string"
   },
   "mergedApiExecutionRoleArn": "string",
   "name": "string",
   "openIDConnectConfig": { 
      "authTTL": number,
      "clientId": "string",
      "iatTTL": number,
      "issuer": "string"
   },
   "ownerContact": "string",
   "queryDepthLimit": number,
   "resolverCountLimit": number,
   "tags": { 
      "string" : "string" 
   },
   "userPoolConfig": { 
      "appIdClientRegex": "string",
      "awsRegion": "string",
      "defaultAction": "string",
      "userPoolId": "string"
   },
   "visibility": "string",
   "xrayEnabled": boolean
}
```

## URI Request Parameters
<a name="API_CreateGraphqlApi_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_CreateGraphqlApi_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [additionalAuthenticationProviders](#API_CreateGraphqlApi_RequestSyntax) **   <a name="appsync-CreateGraphqlApi-request-additionalAuthenticationProviders"></a>
A list of additional authentication providers for the `GraphqlApi` API.  
Type: Array of [AdditionalAuthenticationProvider](API_AdditionalAuthenticationProvider.md) objects  
Required: No

 ** [apiType](#API_CreateGraphqlApi_RequestSyntax) **   <a name="appsync-CreateGraphqlApi-request-apiType"></a>
The value that indicates whether the GraphQL API is a standard API (`GRAPHQL`) or merged API (`MERGED`).  
Type: String  
Valid Values: `GRAPHQL | MERGED`   
Required: No

 ** [authenticationType](#API_CreateGraphqlApi_RequestSyntax) **   <a name="appsync-CreateGraphqlApi-request-authenticationType"></a>
The authentication type: API key, AWS Identity and Access Management (IAM), OpenID Connect (OIDC), Amazon Cognito user pools, or AWS Lambda.  
Type: String  
Valid Values: `API_KEY | AWS_IAM | AMAZON_COGNITO_USER_POOLS | OPENID_CONNECT | AWS_LAMBDA`   
Required: Yes

 ** [enhancedMetricsConfig](#API_CreateGraphqlApi_RequestSyntax) **   <a name="appsync-CreateGraphqlApi-request-enhancedMetricsConfig"></a>
The `enhancedMetricsConfig` object.  
Type: [EnhancedMetricsConfig](API_EnhancedMetricsConfig.md) object  
Required: No

 ** [introspectionConfig](#API_CreateGraphqlApi_RequestSyntax) **   <a name="appsync-CreateGraphqlApi-request-introspectionConfig"></a>
Sets the value of the GraphQL API to enable (`ENABLED`) or disable (`DISABLED`) introspection. If no value is provided, the introspection configuration will be set to `ENABLED` by default. This field will produce an error if the operation attempts to use the introspection feature while this field is disabled.  
For more information about introspection, see [GraphQL introspection](https://graphql.org/learn/introspection/).  
Type: String  
Valid Values: `ENABLED | DISABLED`   
Required: No

 ** [lambdaAuthorizerConfig](#API_CreateGraphqlApi_RequestSyntax) **   <a name="appsync-CreateGraphqlApi-request-lambdaAuthorizerConfig"></a>
Configuration for AWS Lambda function authorization.  
Type: [LambdaAuthorizerConfig](API_LambdaAuthorizerConfig.md) object  
Required: No

 ** [logConfig](#API_CreateGraphqlApi_RequestSyntax) **   <a name="appsync-CreateGraphqlApi-request-logConfig"></a>
The Amazon CloudWatch Logs configuration.  
Type: [LogConfig](API_LogConfig.md) object  
Required: No

 ** [mergedApiExecutionRoleArn](#API_CreateGraphqlApi_RequestSyntax) **   <a name="appsync-CreateGraphqlApi-request-mergedApiExecutionRoleArn"></a>
The Identity and Access Management service role ARN for a merged API. The AppSync service assumes this role on behalf of the Merged API to validate access to source APIs at runtime and to prompt the `AUTO_MERGE` to update the merged API endpoint with the source API changes automatically.  
Type: String  
Required: No

 ** [name](#API_CreateGraphqlApi_RequestSyntax) **   <a name="appsync-CreateGraphqlApi-request-name"></a>
A user-supplied name for the `GraphqlApi`.  
Type: String  
Required: Yes

 ** [openIDConnectConfig](#API_CreateGraphqlApi_RequestSyntax) **   <a name="appsync-CreateGraphqlApi-request-openIDConnectConfig"></a>
The OIDC configuration.  
Type: [OpenIDConnectConfig](API_OpenIDConnectConfig.md) object  
Required: No

 ** [ownerContact](#API_CreateGraphqlApi_RequestSyntax) **   <a name="appsync-CreateGraphqlApi-request-ownerContact"></a>
The owner contact information for an API resource.  
This field accepts any string input with a length of 0 - 256 characters.  
Type: String  
Required: No

 ** [queryDepthLimit](#API_CreateGraphqlApi_RequestSyntax) **   <a name="appsync-CreateGraphqlApi-request-queryDepthLimit"></a>
The maximum depth a query can have in a single request. Depth refers to the amount of nested levels allowed in the body of query. The default value is `0` (or unspecified), which indicates there's no depth limit. If you set a limit, it can be between `1` and `75` nested levels. This field will produce a limit error if the operation falls out of bounds.  
Note that fields can still be set to nullable or non-nullable. If a non-nullable field produces an error, the error will be thrown upwards to the first nullable field available.  
Type: Integer  
Valid Range: Minimum value of 0. Maximum value of 75.  
Required: No

 ** [resolverCountLimit](#API_CreateGraphqlApi_RequestSyntax) **   <a name="appsync-CreateGraphqlApi-request-resolverCountLimit"></a>
The maximum number of resolvers that can be invoked in a single request. The default value is `0` (or unspecified), which will set the limit to `10000`. When specified, the limit value can be between `1` and `10000`. This field will produce a limit error if the operation falls out of bounds.  
Type: Integer  
Valid Range: Minimum value of 0. Maximum value of 10000.  
Required: No

 ** [tags](#API_CreateGraphqlApi_RequestSyntax) **   <a name="appsync-CreateGraphqlApi-request-tags"></a>
A `TagMap` object.  
Type: String to string map  
Map Entries: Maximum number of 50 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Key Pattern: `^(?!aws:)[ a-zA-Z+-=._:/]+$`   
Value Length Constraints: Maximum length of 256.  
Value Pattern: `^[\s\w+-=\.:/@]*$`   
Required: No

 ** [userPoolConfig](#API_CreateGraphqlApi_RequestSyntax) **   <a name="appsync-CreateGraphqlApi-request-userPoolConfig"></a>
The Amazon Cognito user pool configuration.  
Type: [UserPoolConfig](API_UserPoolConfig.md) object  
Required: No

 ** [visibility](#API_CreateGraphqlApi_RequestSyntax) **   <a name="appsync-CreateGraphqlApi-request-visibility"></a>
Sets the value of the GraphQL API to public (`GLOBAL`) or private (`PRIVATE`). If no value is provided, the visibility will be set to `GLOBAL` by default. This value cannot be changed once the API has been created.  
Type: String  
Valid Values: `GLOBAL | PRIVATE`   
Required: No

 ** [xrayEnabled](#API_CreateGraphqlApi_RequestSyntax) **   <a name="appsync-CreateGraphqlApi-request-xrayEnabled"></a>
A flag indicating whether to use AWS X-Ray tracing for the `GraphqlApi`.  
Type: Boolean  
Required: No

## Response Syntax
<a name="API_CreateGraphqlApi_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "graphqlApi": { 
      "additionalAuthenticationProviders": [ 
         { 
            "authenticationType": "string",
            "lambdaAuthorizerConfig": { 
               "authorizerResultTtlInSeconds": number,
               "authorizerUri": "string",
               "identityValidationExpression": "string"
            },
            "openIDConnectConfig": { 
               "authTTL": number,
               "clientId": "string",
               "iatTTL": number,
               "issuer": "string"
            },
            "userPoolConfig": { 
               "appIdClientRegex": "string",
               "awsRegion": "string",
               "userPoolId": "string"
            }
         }
      ],
      "apiId": "string",
      "apiType": "string",
      "arn": "string",
      "authenticationType": "string",
      "dns": { 
         "string" : "string" 
      },
      "enhancedMetricsConfig": { 
         "dataSourceLevelMetricsBehavior": "string",
         "operationLevelMetricsConfig": "string",
         "resolverLevelMetricsBehavior": "string"
      },
      "introspectionConfig": "string",
      "lambdaAuthorizerConfig": { 
         "authorizerResultTtlInSeconds": number,
         "authorizerUri": "string",
         "identityValidationExpression": "string"
      },
      "logConfig": { 
         "cloudWatchLogsRoleArn": "string",
         "excludeVerboseContent": boolean,
         "fieldLogLevel": "string"
      },
      "mergedApiExecutionRoleArn": "string",
      "name": "string",
      "openIDConnectConfig": { 
         "authTTL": number,
         "clientId": "string",
         "iatTTL": number,
         "issuer": "string"
      },
      "owner": "string",
      "ownerContact": "string",
      "queryDepthLimit": number,
      "resolverCountLimit": number,
      "tags": { 
         "string" : "string" 
      },
      "uris": { 
         "string" : "string" 
      },
      "userPoolConfig": { 
         "appIdClientRegex": "string",
         "awsRegion": "string",
         "defaultAction": "string",
         "userPoolId": "string"
      },
      "visibility": "string",
      "wafWebAclArn": "string",
      "xrayEnabled": boolean
   }
}
```

## Response Elements
<a name="API_CreateGraphqlApi_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [graphqlApi](#API_CreateGraphqlApi_ResponseSyntax) **   <a name="appsync-CreateGraphqlApi-response-graphqlApi"></a>
The `GraphqlApi`.  
Type: [GraphqlApi](API_GraphqlApi.md) object

## Errors
<a name="API_CreateGraphqlApi_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** ApiLimitExceededException **   
The GraphQL API exceeded a limit. Try your request again.  
HTTP Status Code: 400

 ** BadRequestException **   
The request is not well formed. For example, a value is invalid or a required field is missing. Check the field values, and then try again.    
 ** detail **   
Provides further details for the reason behind the bad request. For reason type `CODE_ERROR`, the detail will contain a list of code errors.  
 ** reason **   
Provides context for the cause of the bad request. The only supported value is `CODE_ERROR`.
HTTP Status Code: 400

 ** ConcurrentModificationException **   
Another modification is in progress at this time and it must complete before you can make your change.  
HTTP Status Code: 409

 ** InternalFailureException **   
An internal AWS AppSync error occurred. Try your request again.  
HTTP Status Code: 500

 ** LimitExceededException **   
The request exceeded a limit. Try your request again.  
HTTP Status Code: 429

 ** UnauthorizedException **   
You aren't authorized to perform this operation.  
HTTP Status Code: 401

## See Also
<a name="API_CreateGraphqlApi_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/appsync-2017-07-25/CreateGraphqlApi) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/appsync-2017-07-25/CreateGraphqlApi) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/appsync-2017-07-25/CreateGraphqlApi) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/appsync-2017-07-25/CreateGraphqlApi) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/appsync-2017-07-25/CreateGraphqlApi) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/appsync-2017-07-25/CreateGraphqlApi) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/appsync-2017-07-25/CreateGraphqlApi) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/appsync-2017-07-25/CreateGraphqlApi) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/appsync-2017-07-25/CreateGraphqlApi) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/appsync-2017-07-25/CreateGraphqlApi) 

# CreateResolver
<a name="API_CreateResolver"></a>

Creates a `Resolver` object.

A resolver converts incoming requests into a format that a data source can understand, and converts the data source's responses into GraphQL.

## Request Syntax
<a name="API_CreateResolver_RequestSyntax"></a>

```
POST /v1/apis/apiId/types/typeName/resolvers HTTP/1.1
Content-type: application/json

{
   "cachingConfig": { 
      "cachingKeys": [ "string" ],
      "ttl": number
   },
   "code": "string",
   "dataSourceName": "string",
   "fieldName": "string",
   "kind": "string",
   "maxBatchSize": number,
   "metricsConfig": "string",
   "pipelineConfig": { 
      "functions": [ "string" ]
   },
   "requestMappingTemplate": "string",
   "responseMappingTemplate": "string",
   "runtime": { 
      "name": "string",
      "runtimeVersion": "string"
   },
   "syncConfig": { 
      "conflictDetection": "string",
      "conflictHandler": "string",
      "lambdaConflictHandlerConfig": { 
         "lambdaConflictHandlerArn": "string"
      }
   }
}
```

## URI Request Parameters
<a name="API_CreateResolver_RequestParameters"></a>

The request uses the following URI parameters.

 ** [apiId](#API_CreateResolver_RequestSyntax) **   <a name="appsync-CreateResolver-request-uri-apiId"></a>
The ID for the GraphQL API for which the resolver is being created.  
Required: Yes

 ** [typeName](#API_CreateResolver_RequestSyntax) **   <a name="appsync-CreateResolver-request-uri-typeName"></a>
The name of the `Type`.  
Length Constraints: Minimum length of 1. Maximum length of 65536.  
Pattern: `[_A-Za-z][_0-9A-Za-z]*`   
Required: Yes

## Request Body
<a name="API_CreateResolver_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [cachingConfig](#API_CreateResolver_RequestSyntax) **   <a name="appsync-CreateResolver-request-cachingConfig"></a>
The caching configuration for the resolver.  
Type: [CachingConfig](API_CachingConfig.md) object  
Required: No

 ** [code](#API_CreateResolver_RequestSyntax) **   <a name="appsync-CreateResolver-request-code"></a>
The `resolver` code that contains the request and response functions. When code is used, the `runtime` is required. The `runtime` value must be `APPSYNC_JS`.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 32768.  
Required: No

 ** [dataSourceName](#API_CreateResolver_RequestSyntax) **   <a name="appsync-CreateResolver-request-dataSourceName"></a>
The name of the data source for which the resolver is being created.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 65536.  
Pattern: `[_A-Za-z][_0-9A-Za-z]*`   
Required: No

 ** [fieldName](#API_CreateResolver_RequestSyntax) **   <a name="appsync-CreateResolver-request-fieldName"></a>
The name of the field to attach the resolver to.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 65536.  
Pattern: `[_A-Za-z][_0-9A-Za-z]*`   
Required: Yes

 ** [kind](#API_CreateResolver_RequestSyntax) **   <a name="appsync-CreateResolver-request-kind"></a>
The resolver type.  
+  **UNIT**: A UNIT resolver type. A UNIT resolver is the default resolver type. You can use a UNIT resolver to run a GraphQL query against a single data source.
+  **PIPELINE**: A PIPELINE resolver type. You can use a PIPELINE resolver to invoke a series of `Function` objects in a serial manner. You can use a pipeline resolver to run a GraphQL query against multiple data sources.
Type: String  
Valid Values: `UNIT | PIPELINE`   
Required: No

 ** [maxBatchSize](#API_CreateResolver_RequestSyntax) **   <a name="appsync-CreateResolver-request-maxBatchSize"></a>
The maximum batching size for a resolver.  
Type: Integer  
Valid Range: Minimum value of 0. Maximum value of 2000.  
Required: No

 ** [metricsConfig](#API_CreateResolver_RequestSyntax) **   <a name="appsync-CreateResolver-request-metricsConfig"></a>
Enables or disables enhanced resolver metrics for specified resolvers. Note that `metricsConfig` won't be used unless the `resolverLevelMetricsBehavior` value is set to `PER_RESOLVER_METRICS`. If the `resolverLevelMetricsBehavior` is set to `FULL_REQUEST_RESOLVER_METRICS` instead, `metricsConfig` will be ignored. However, you can still set its value.  
 `metricsConfig` can be `ENABLED` or `DISABLED`.  
Type: String  
Valid Values: `ENABLED | DISABLED`   
Required: No

 ** [pipelineConfig](#API_CreateResolver_RequestSyntax) **   <a name="appsync-CreateResolver-request-pipelineConfig"></a>
The `PipelineConfig`.  
Type: [PipelineConfig](API_PipelineConfig.md) object  
Required: No

 ** [requestMappingTemplate](#API_CreateResolver_RequestSyntax) **   <a name="appsync-CreateResolver-request-requestMappingTemplate"></a>
The mapping template to use for requests.  
A resolver uses a request mapping template to convert a GraphQL expression into a format that a data source can understand. Mapping templates are written in Apache Velocity Template Language (VTL).  
VTL request mapping templates are optional when using an AWS Lambda data source. For all other data sources, VTL request and response mapping templates are required.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 65536.  
Pattern: `^.*$`   
Required: No

 ** [responseMappingTemplate](#API_CreateResolver_RequestSyntax) **   <a name="appsync-CreateResolver-request-responseMappingTemplate"></a>
The mapping template to use for responses from the data source.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 65536.  
Pattern: `^.*$`   
Required: No

 ** [runtime](#API_CreateResolver_RequestSyntax) **   <a name="appsync-CreateResolver-request-runtime"></a>
Describes a runtime used by an AWS AppSync pipeline resolver or AWS AppSync function. Specifies the name and version of the runtime to use. Note that if a runtime is specified, code must also be specified.  
Type: [AppSyncRuntime](API_AppSyncRuntime.md) object  
Required: No

 ** [syncConfig](#API_CreateResolver_RequestSyntax) **   <a name="appsync-CreateResolver-request-syncConfig"></a>
The `SyncConfig` for a resolver attached to a versioned data source.  
Type: [SyncConfig](API_SyncConfig.md) object  
Required: No

## Response Syntax
<a name="API_CreateResolver_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "resolver": { 
      "cachingConfig": { 
         "cachingKeys": [ "string" ],
         "ttl": number
      },
      "code": "string",
      "dataSourceName": "string",
      "fieldName": "string",
      "kind": "string",
      "maxBatchSize": number,
      "metricsConfig": "string",
      "pipelineConfig": { 
         "functions": [ "string" ]
      },
      "requestMappingTemplate": "string",
      "resolverArn": "string",
      "responseMappingTemplate": "string",
      "runtime": { 
         "name": "string",
         "runtimeVersion": "string"
      },
      "syncConfig": { 
         "conflictDetection": "string",
         "conflictHandler": "string",
         "lambdaConflictHandlerConfig": { 
            "lambdaConflictHandlerArn": "string"
         }
      },
      "typeName": "string"
   }
}
```

## Response Elements
<a name="API_CreateResolver_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [resolver](#API_CreateResolver_ResponseSyntax) **   <a name="appsync-CreateResolver-response-resolver"></a>
The `Resolver` object.  
Type: [Resolver](API_Resolver.md) object

## Errors
<a name="API_CreateResolver_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** BadRequestException **   
The request is not well formed. For example, a value is invalid or a required field is missing. Check the field values, and then try again.    
 ** detail **   
Provides further details for the reason behind the bad request. For reason type `CODE_ERROR`, the detail will contain a list of code errors.  
 ** reason **   
Provides context for the cause of the bad request. The only supported value is `CODE_ERROR`.
HTTP Status Code: 400

 ** ConcurrentModificationException **   
Another modification is in progress at this time and it must complete before you can make your change.  
HTTP Status Code: 409

 ** InternalFailureException **   
An internal AWS AppSync error occurred. Try your request again.  
HTTP Status Code: 500

 ** NotFoundException **   
The resource specified in the request was not found. Check the resource, and then try again.  
HTTP Status Code: 404

 ** UnauthorizedException **   
You aren't authorized to perform this operation.  
HTTP Status Code: 401

## See Also
<a name="API_CreateResolver_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/appsync-2017-07-25/CreateResolver) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/appsync-2017-07-25/CreateResolver) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/appsync-2017-07-25/CreateResolver) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/appsync-2017-07-25/CreateResolver) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/appsync-2017-07-25/CreateResolver) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/appsync-2017-07-25/CreateResolver) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/appsync-2017-07-25/CreateResolver) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/appsync-2017-07-25/CreateResolver) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/appsync-2017-07-25/CreateResolver) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/appsync-2017-07-25/CreateResolver) 

# CreateType
<a name="API_CreateType"></a>

Creates a `Type` object.

## Request Syntax
<a name="API_CreateType_RequestSyntax"></a>

```
POST /v1/apis/apiId/types HTTP/1.1
Content-type: application/json

{
   "definition": "string",
   "format": "string"
}
```

## URI Request Parameters
<a name="API_CreateType_RequestParameters"></a>

The request uses the following URI parameters.

 ** [apiId](#API_CreateType_RequestSyntax) **   <a name="appsync-CreateType-request-uri-apiId"></a>
The API ID.  
Required: Yes

## Request Body
<a name="API_CreateType_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [definition](#API_CreateType_RequestSyntax) **   <a name="appsync-CreateType-request-definition"></a>
The type definition, in GraphQL Schema Definition Language (SDL) format.  
For more information, see the [GraphQL SDL documentation](http://graphql.org/learn/schema/).  
Type: String  
Required: Yes

 ** [format](#API_CreateType_RequestSyntax) **   <a name="appsync-CreateType-request-format"></a>
The type format: SDL or JSON.  
Type: String  
Valid Values: `SDL | JSON`   
Required: Yes

## Response Syntax
<a name="API_CreateType_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "type": { 
      "arn": "string",
      "definition": "string",
      "description": "string",
      "format": "string",
      "name": "string"
   }
}
```

## Response Elements
<a name="API_CreateType_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [type](#API_CreateType_ResponseSyntax) **   <a name="appsync-CreateType-response-type"></a>
The `Type` object.  
Type: [Type](API_Type.md) object

## Errors
<a name="API_CreateType_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** BadRequestException **   
The request is not well formed. For example, a value is invalid or a required field is missing. Check the field values, and then try again.    
 ** detail **   
Provides further details for the reason behind the bad request. For reason type `CODE_ERROR`, the detail will contain a list of code errors.  
 ** reason **   
Provides context for the cause of the bad request. The only supported value is `CODE_ERROR`.
HTTP Status Code: 400

 ** ConcurrentModificationException **   
Another modification is in progress at this time and it must complete before you can make your change.  
HTTP Status Code: 409

 ** InternalFailureException **   
An internal AWS AppSync error occurred. Try your request again.  
HTTP Status Code: 500

 ** NotFoundException **   
The resource specified in the request was not found. Check the resource, and then try again.  
HTTP Status Code: 404

 ** UnauthorizedException **   
You aren't authorized to perform this operation.  
HTTP Status Code: 401

## See Also
<a name="API_CreateType_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/appsync-2017-07-25/CreateType) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/appsync-2017-07-25/CreateType) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/appsync-2017-07-25/CreateType) 
[...]
